open Term

(* NOTE: this module handle rules for A if
  the rules hold either
        f(f(x,y),z) -> f(x,f(y,z)) or
        f(x,f(y,z)) -> f(f(x,y),z)
  we not require thad rules holds both
*)
val terminate : string list -> Trs.t -> bool
val acrpo : string list -> Trs.t -> bool
(* predicates *)
val rule_A : Rule.t -> bool
val rule_C : Rule.t -> bool
(* generator *)
val a_sym : Trs.t -> string list
val c_sym : Trs.t -> string list
val ac_sym : Trs.t -> string list
val a_rules : Trs.t -> Trs.t
val c_rules : Trs.t -> Trs.t
val ac_rules : Trs.t -> Trs.t
val a_class : string -> Trs.t
val c_class : string -> Trs.t
